%define expat_version           1.95.5
%define glib2_version           2.2.0
%define dbus_version            0.22
%define pygtk2			2.0.0
%define gnome_python2		2.0.0
%define libselinux_version      1.17.14-1
%define udev_version            034-2
%define util_linux_version      2.12a-16
%define libcap_version          1.10-20
%define doxygen_version         1.3.9.1-1

%define hal_user_uid           68

Summary: Hardware Abstraction Layer
Name: hal
Version: 0.4.2
Release: 9%{?dist}
URL: http://www.freedesktop.org/Software/hal
Source0: %{name}-%{version}.tar.gz
Patch0: hal-null-block-device.patch
Patch1: hal-osspec.patch
Patch2: hal-sync-callouts.patch
Patch3: hal-hotplug-input-quiet.patch
Patch4: hal-0.4.2-device-info-parse.patch
Patch5: hal-0.4.2-skip-sysfs-config.patch
Patch6: hal-0.4.2-is-mounted-crasher.patch
Patch7: hal-0.4.2-dont-delete-slash.patch
Patch8: hal-0.4.2-plug-hotplug-memleak.patch
Patch9: hal-0.4.2-larger-mtab-buffer.patch
Patch10: hal-0.4.2-size_t.patch
Patch11: hal-0.4.2-remove-async-matching.patch
License: AFL/GPL
Group: System Environment/Libraries
BuildRoot: %{_tmppath}/%{name}-root
PreReq: chkconfig
BuildRequires: expat-devel >= %{expat_version}
BuildRequires: glib2-devel >= %{glib2_version}
BuildRequires: dbus-devel   = %{dbus_version}
BuildRequires: python-devel
BuildRequires: hwdata
BuildRequires: libselinux-devel >= %{libselinux_version}
BuildRequires: libcap-devel >= %{libcap_version}
BuildRequires: doxygen >= %{doxygen_version}
Requires: dbus = %{dbus_version}
Requires: dbus-glib = %{dbus_version}
Requires: glib2 >= %{glib2_version}
Requires: udev >= %{udev_version} 
Requires: util-linux >= %{util_linux_version} 
Requires: libselinux >= %{libselinux_version}

%description

HAL is daemon for collection and maintaining information from several
sources about the hardware on the system. It provdes a live device
list through D-BUS.

%package gnome
Summary: GNOME based device manager for HAL
Group: Development/Libraries
Requires: %name = %{version}-%{release}
Requires: dbus-python >= %{dbus_version}
Requires: pygtk2 >= %{pygtk2} 
Requires: gnome-python2 >= %{gnome_python2} 

%description gnome
GNOME program for displaying the devices detected by HAL


%package devel
Summary: Libraries and headers for HAL
Group: Development/Libraries
Requires: %name = %{version}-%{release}
Requires: dbus-devel = %{dbus_version}

%description devel

Headers, static libraries and API docs for HAL.

%prep
%setup -q
%patch0 -p1 -b .null-block-device
%patch1 -p1 -b .osspec
%patch2 -p1 -b .sync-callouts
%patch3 -p1 -b .quiet
%patch4 -p1 -b .fdi-typo
%patch5 -p1 -b .dont-read-config
%patch6 -p1 -b .is-mounted-crasher
%patch7 -p1 -b .dont-delete-slash
%patch8 -p1 -b .plug-hotplug-memleak.patch
%patch9 -p1 -b .larger-mtab-buffer
%patch10 -p1 -b .sizet
%patch11 -p1 -b .remove-async-matching

%build

%configure --disable-docbook-docs --enable-fstab-sync --enable-hotplug-map --with-init-scripts=redhat --with-pid-file=/var/run/haldaemon.pid --enable-selinux --enable-pcmcia-support
make

%install
make install DESTDIR=$RPM_BUILD_ROOT

rm -f $RPM_BUILD_ROOT%{_libdir}/*.la

%clean
rm -rf %{buildroot}

%pre
# Add the "haldaemon" user
/usr/sbin/useradd -c 'HAL daemon' -u %{hal_user_uid} \
	-s /sbin/nologin -r -d '/' haldaemon 2> /dev/null || :

%post
/sbin/ldconfig
/sbin/chkconfig --add haldaemon

%preun
if [ $1 = 0 ]; then
    service haldaemon stop > /dev/null 2>&1
    /sbin/chkconfig --del haldaemon
fi

%postun
/sbin/ldconfig
if [ "$1" -ge "1" ]; then
  service haldaemon condrestart > /dev/null 2>&1
fi

%files
%defattr(-,root,root)
#%doc COPYING ChangeLog NEWS

%dir %{_sysconfdir}/dbus-1/system.d

%config %{_sysconfdir}/dbus-1/system.d/hal.conf
%config %{_sysconfdir}/rc.d/init.d/*

%dir %{_sysconfdir}/hal
%dir %{_sysconfdir}/hal/capability.d
%dir %{_sysconfdir}/hal/device.d
%dir %{_sysconfdir}/hal/property.d

%config %{_sysconfdir}/hal/hald.conf

%{_sbindir}/hald
%{_sbindir}/fstab-sync

%{_bindir}/lshal
%{_bindir}/hal-get-property
%{_bindir}/hal-set-property

%{_libdir}/*hal*.so.*

%{_libexecdir}/hal.hotplug
/etc/hotplug.d/default/20-hal.hotplug

%{_libexecdir}/hal.dev
%{_sysconfdir}/dev.d/default/10-hal.dev

%{_libexecdir}/hal-hotplug-map

%dir %{_datadir}/hal
%dir %{_datadir}/hal/fdi
%{_datadir}/hal/fdi/*
%{_datadir}/locale/*
%{_datadir}/man/*
%{_datadir}/doc/hal-%{version}/conf/*

%{_sysconfdir}/hal/device.d/40-hal-hotplug-map.hal
# allow users to make this symlink point to /bin/false cf. the fstab-sync
# manpage
%config(noreplace) %{_sysconfdir}/hal/device.d/50-fstab-sync.hal

%files devel
%defattr(-,root,root)

%{_libdir}/lib*.a
%{_libdir}/lib*.so
%{_libdir}/pkgconfig/*
%{_includedir}/*
%{_datadir}/doc/hal-%{version}/api/*
# TODO: include hal-spec



%files gnome
%defattr(-,root,root)

%dir %{_datadir}/hal/device-manager
%{_datadir}/hal/device-manager/*
%{_bindir}/hal-device-manager


%changelog
* Wed Jan 05 2011 - Richard Hughes <rhughes@redhat.com> - 0.4.2-9.el4_8
- Remove the device store asynchronous matching, which is a backport of
  an upstream git commit of many years ago.
- This fixes hald crashing when removing a USB stick, which was reported
  in IT#277422 and was verified by the customer.
- Resolves: #661723

* Thu Apr 10 2008 - David Zeuthen <davidz@redhat.com> - 0.4.2-8.EL4
- Make fstab-sync properly handle the ENOSPC case
- Resolves: #250419

* Thu Aug 02 2007 - David Zeuthen <davidz@redhat.com> - 0.4.2-7.EL4
- Fix memory leak when unplugging/replugging a USB device
- Resolves: #247734
- Use a larger line buffer for the /etc/mtab file (#238501)

* Wed Jan 24 2007 - Bastien Nocera <bnocera@redhat.com> - 0.4.2-6.EL4
- Fix wrong patch being used for (Bug #172835)

* Wed Jan 24 2007 - Bastien Nocera <bnocera@redhat.com> - 0.4.2-5.EL4
- Add patch to fix the ide-drives.fdi parsing, missing closing element
  (Bug #164631)
- Patch by Jeff Layton <jlayton@redhat.com> to avoid poking the "config"
  file in sysfs sub-dirs, as it can cause problems for some devices
  (Bug #172835)
- Avoid fstab-sync crashing when checking whether a partition is mounted
  (comparing an uninitialised variable) (Bug #175523)
- Add patch by Keiichi Mori <kmori@redhat.com> to not delete the '/' entry
  from /etc/fstab (strcmp of a 0-len string always succeeds)
  (Bug #192410)

* Fri May 05 2006 John (J5) Palmieri <johnp@redhat.com> - 0.4.2-4.EL4
- Add patch to stop HAL complaining about DEVPATH not being set on
  kernels that do not support it (Bug #169387)

* Wed Dec 21 2005 John (J5) Palmieri <johnp@redhat.com> 0.4.2-3.EL4
- Rebuild with gcc-3.4.5-2

* Thu Dec 01 2005 John (J5) Palmieri <johnp@redhat.com> 0.4.2-2.EL4
- Add patch to fix segfault in fstab-sync when ejecting CD (Bug 163772)
- Add patch to fix hotplug issues with USB cds (Bug 164777)
- Add patch to run callouts synchronously (Bug 167811)

* Wed Dec 01 2004 David Zeuthen <davidz@redhat,com> 0.4.2-1.EL4
- Upstream release 0.4.2
- Drop all patches as they are committed upstream
- Fixes for #140557, #139227, #139962, #139600, #136971
- Workaround for #138148 through blacklisting certain IDE optical drives

* Tue Oct 19 2004 David Zeuthen <davidz@redhat,com> 0.4.0-5
- Make hal work with PCMCIA IDE hotpluggable devices (#133943)
- Fixup URL listed from rpm -qi (#136396)
- Add Portuguese translations for hal
- Fix addition of Russian and Hungarian translations

* Mon Oct 18 2004 David Zeuthen <davidz@redhat.com> 0.4.0-4
- Make hald cope with missing hotplug events from buggy drivers (#135202)
- Fix the order of mount options in fstab-sync (#136191)
- Allow x86 legacy floppy drives in default policy (#133777)
- Fix fstab-sync crashing without any options and not run from hald (#136214)
- man page for fstab-sync references non-existing files (#136026)
- Add Russian translations for hal (#135853)
- Add Hungarian translations for hal

* Fri Oct 15 2004 David Zeuthen <davidz@redhat.com> 0.4.0-3
- Fix bad use of O_NONBLOCK as the 2.6.8-1.624 kernel exposes this (#135886)
- Never use the UUID as mount point candidate in the default policy 
  as it is unfriendly (#135907)
- Fix a trivial bug in fstab-sync so the syslog messages actually expose
  the device name instead of just the word foo

* Thu Oct 14 2004 David Zeuthen <davidz@redhat.com> 0.4.0-2
- Fix issue with fstab-sync not cleaning /etc/fstab on startup

* Thu Oct 14 2004 David Zeuthen <davidz@redhat.com> 0.4.0-1
- Update to upstream stable version 0.4.0
- Remove patch for libhal shutdown since that is now upstream
- fstab-sync: man page, adds comment in /etc/fstab pointing to man page

* Fri Oct 01 2004 David Zeuthen <davidz@redhat.com> 0.2.98.cvs20040929-3
- Fix a bug so libhal actually invoke callback functions when needed

* Fri Oct 01 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.98.cvs20040929-2
- Use "user" mount flag for now until "pamconsole" flag gets into mount

* Wed Sep 29 2004 David Zeuthen <davidz@redhat.com> 0.2.98.cvs20040929-1
- Update to upstream CVS version
- Enable libselinux again

* Mon Sep 27 2004 David Zeuthen <davidz@redhat.com> 0.2.98.cvs20040927-1
- Update to upstream CVS version

* Fri Sep 24 2004 David Zeuthen <davidz@redhat.com> 0.2.98.cvs20040923-1
- Update to upstream CVS release
- Include libhal-storage library
- Should close bug #132876

* Mon Sep 20 2004 David Zeuthen <davidz@redhat.com> 0.2.98-4
- Rebuilt

* Mon Sep 20 2004 David Zeuthen <davidz@redhat.com> 0.2.98-3
- Rebuilt

* Mon Sep 20 2004 David Zeuthen <davidz@redhat.com> 0.2.98-2
- Temporarily disable explicit requirement for libselinux

* Mon Sep 20 2004 David Zeuthen <davidz@redhat.com> 0.2.98-1
- Update to upstream release 0.2.98. 
- Use --with-pid-file so we don't depend on /etc/redhat-release

* Wed Sep 01 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040901-1
- Update to upstream CVS HEAD

* Tue Aug 31 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040831-3
- Add UID for haldaemon user

* Tue Aug 31 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040831-2
- Rebuilt with a newer snapshot.

* Fri Aug 27 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040827-3
- Rebuilt

* Fri Aug 27 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040827-2
- Rebuilt
- Closes RH Bug #130971

* Fri Aug 27 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040827-1
- Update to upstream CVS HEAD. 
- Should close RH Bug #130588

* Wed Aug 25 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040823-3
- Rebuilt

* Wed Aug 25 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040823-2
- Apply a patch so hald doesn't hang on startup.

* Mon Aug 23 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040823-1
- Update to upstream CVS HEAD
- Remove symlinking of fstab-sync from specfile since this is now being
  done in the package

* Mon Aug 23 2004 Florian La Roche <Florian.LaRoche@redhat.de>
- change the %%define names to not use "-"

* Thu Aug 19 2004 David Zeuthen <davidz@redhat.com> 0.2.97.cvs20040819-1
- Update to upstream CVS HEAD
- Remove suid patch as it is fixed upstream
- Fix some dependency issues (RH Bug #130202)

* Wed Aug 18 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.97-2
- Add stopgap patch to remove suid from mount flags (RH Bug #130290)

* Mon Aug 16 2004 David Zeuthen <davidz@redhat.com> 0.2.97-1
- update to upstream release 0.2.97
- use kudzu option in fstab-sync since updfstab is now disabled

* Thu Aug 12 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.96-2
- fixed Requires lines to use %{} instead of ${}
- made dbus related requires lines use the = condition instead of =<
  because the dbus API is still in flux

* Thu Aug 12 2004 David Zeuthen <davidz@redhat.com> 0.2.96
- Update to upstream release 0.2.96
- Symlink fstab-sync into /etc/hal/device.d on install

* Fri Aug 06 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.95.cvs20040802-2
- Base hal package no longer requires python

* Mon Aug 02 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.95.cvs20040802-1
- Update to CVS head
- Remove Dan's patches as they were commited to CVS

* Fri Jul 30 2004 Dan Williams <dcbw@redhat.com> 0.2.93.cvs.20040712-2
- Fix netlink sockets pointer arithmetic bug

* Mon Jul 12 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.93.cvs.20040712-1
- Update to new CVS version as of 7-12-2004

* Fri Jun 25 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.92.cvs.20040611-2
- take out fstab-update.sh from install
- add to rawhide
 
* Fri Jun 11 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.92.cvs.20040611-1 
- update to CVS head as of 6-11-2004 which contains dcbw's 
  network link status fix 

* Wed Jun 9 2004 Ray Strode <rstrode@redhat.com> 0.2.91.cvs20040527-2
- added dependency on udev

* Wed May 12 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.91.cvs20040527-1
- update to CVS head as of 5-27-2004 which contains fixes for PCMCIA
  and wireless network devices.

* Wed May 12 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.90.cvs20040511-3
- added hal-0.2.90.cvs20040511.callbackscripts.patch which installs 
  the file system mounting script in /etc/hal/device.d

* Wed May 12 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.90.cvs20040511-2
- added the %{_sysconfigdir}/hal directory tree to %files 

* Tue May 11 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.90.cvs20040511-1
- update to CVS head as of 5-11-2004

* Wed May 5 2004 Christopher Blizzard <blizzard@redhat.com> 0.2.90-2
- Install hal.dev from /etc/dev.d/default/

* Mon Apr 19 2004 John (J5) Palmieri <johnp@redhat.com> 0.2.90-1
- upstream update

* Mon Apr 19 2004 John (J5) Palmieri <johnp@redhat.com> 0.2-1 
- initial checkin to package repository
- added dependency to the dbus-python package
- added %{_libexecdir}/hal.dev to teh %files section
